
package com.example.gwtpwj.client.app;

import com.google.gwt.event.shared.GwtEvent.Type;
import com.google.inject.Inject;
import com.google.web.bindery.event.shared.EventBus;
import com.gwtplatform.mvp.client.ChangeTabHandler;
import com.gwtplatform.mvp.client.RequestTabsHandler;
import com.gwtplatform.mvp.client.TabContainerPresenter;
import com.gwtplatform.mvp.client.TabView;
import com.gwtplatform.mvp.client.annotations.ChangeTab;
import com.gwtplatform.mvp.client.annotations.ContentSlot;
import com.gwtplatform.mvp.client.annotations.ProxyStandard;
import com.gwtplatform.mvp.client.annotations.RequestTabs;
import com.gwtplatform.mvp.client.proxy.Proxy;
import com.gwtplatform.mvp.client.proxy.RevealContentHandler;

public class ApplicationPresenter
    extends
    TabContainerPresenter<ApplicationPresenter.MyView,
    ApplicationPresenter.MyProxy>
{
    public interface MyView extends TabView {
        void refreshTabs();
    }

    /**
     * This will be the event sent to our "unknown" child presenters, in order
     * for them to register their tabs.
     */
    @RequestTabs
    public static final Type<RequestTabsHandler> TYPE_RequestTabs =
        new Type<RequestTabsHandler>();

    /**
     * Fired by child proxie's when their tab content is changed.
     */
    @ChangeTab
    public static final Type<ChangeTabHandler> TYPE_ChangeTab =
        new Type<ChangeTabHandler>();

    /**
     * Use this in leaf presenters, inside their {@link #revealInParent} method.
     */
    @ContentSlot
    public static final Type<RevealContentHandler<?>> TYPE_SetTabContent =
        new Type<RevealContentHandler<?>>();

    private final MyView view;

    @ProxyStandard
    public interface MyProxy extends Proxy<ApplicationPresenter> {
    }

    @Inject
    public ApplicationPresenter(final EventBus eventBus, final MyView view,
        final MyProxy proxy) {
        super(eventBus, view, proxy,
            TYPE_SetTabContent, TYPE_RequestTabs, TYPE_ChangeTab,
            RevealType.Root);
        this.view = view;
    }

    @Override
    protected void onBind() {
        super.onBind();
        view.refreshTabs();
    }

    // @Override
    // protected void onReset() {
    // super.onReset();
    // view.refreshTabs();
    // }
    //
    // @Override
    // protected void onReveal() {
    // super.onReveal();
    // view.refreshTabs();
    // }

    // @ProxyEvent
    // @Override
    // public void onCurrentUserChanged(CurrentUserChangedEvent event) {
    // getView().refreshTabs();
    // }

}
