
package com.example.gwtpwj.client.app;

import javax.inject.Inject;

import org.gwt.advanced.client.util.ThemeHelper;


import com.example.gwtpwj.client.app.ui.tabs.RoundTabPanel;
import com.google.gwt.event.logical.shared.ResizeEvent;
import com.google.gwt.event.logical.shared.ResizeHandler;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Widget;
import com.gwtplatform.mvp.client.Tab;
import com.gwtplatform.mvp.client.TabData;
import com.gwtplatform.mvp.client.ViewImpl;

public class ApplicationView extends ViewImpl implements
    ApplicationPresenter.MyView, ResizeHandler {

    private static final int TAB_BAR_HEIGHT = 44;

    public interface Binder extends UiBinder<Widget, ApplicationView> {
    }

    @UiField(provided = true)
    RoundTabPanel tabPanel;

    private Widget widget;

    @Inject
    public ApplicationView(final Binder uiBinder, RoundTabPanel tabPanel) {
        this.tabPanel = tabPanel;
        widget = uiBinder.createAndBindUi(this);
        ThemeHelper.getInstance().setThemeName("ascetic");
    }

    @Override
    public Tab addTab(TabData tabData, String historyToken) {
        return tabPanel.addTab(tabData, historyToken);
    }

    @Override
    public void removeTab(Tab tab) {
        tabPanel.removeTab(tab);
    }

    @Override
    public void removeTabs() {
        tabPanel.removeTabs();
    }

    @Override
    public void setActiveTab(Tab tab) {
        tabPanel.setActiveTab(tab);
    }

    @Override
    public void changeTab(Tab tab, TabData tabData, String historyToken) {
        tabPanel.changeTab(tab, tabData, historyToken);
    }

    @Override
    public void setInSlot(Object slot, Widget content) {
        if (slot == ApplicationPresenter.TYPE_SetTabContent) {
            tabPanel.setPanelContent(content);
        } else {
            super.setInSlot(slot, content);
        }
    }

    @Override
    public Widget asWidget() {
        Window.addResizeHandler(this);
        resize();
        return widget;
    }

    @Override
    public void refreshTabs() {
        tabPanel.refreshTabs();
    }

    @Override
    public void onResize(ResizeEvent event) {
        resize();
    }
    private void resize()
    {
        int clientHeight = Window.getClientHeight();
        int height = clientHeight
            - TAB_BAR_HEIGHT;

        int width = Window.getClientWidth() - 4;
        // tabPanel.setPixelSize(width, height
        // );

        // summaryPane.setPixelSize(width, height);
        // inputPane.setPixelSize(width, height);
    }

}
