package com.example.gwtpwj.client.app.input;

import java.util.logging.Logger;


import com.example.gwtpwj.client.app.ApplicationPresenter;
import com.example.gwtpwj.client.model.IGwtNumberFormatSux;
import com.example.gwtpwj.client.place.NameTokens;
import com.google.inject.Inject;
import com.google.web.bindery.event.shared.EventBus;
import com.gwtplatform.mvp.client.HasUiHandlers;
import com.gwtplatform.mvp.client.Presenter;
import com.gwtplatform.mvp.client.View;
import com.gwtplatform.mvp.client.annotations.NameToken;
import com.gwtplatform.mvp.client.annotations.ProxyStandard;
import com.gwtplatform.mvp.client.annotations.TabInfo;
import com.gwtplatform.mvp.client.proxy.TabContentProxyPlace;

public class InputTabPresenter extends
    Presenter<InputTabPresenter.MyView, InputTabPresenter.MyProxy>
    implements InputTabUiHandlers
{
    private static Logger log = Logger.getLogger(
        InputTabPresenter.class.getName());

    private final MyView view;

    private final EventBus eventBus;

    private IGwtNumberFormatSux format;


    public interface MyView extends View
        , HasUiHandlers<InputTabUiHandlers>
    {
        void setValue(String value);

    }

    @ProxyStandard
    @NameToken(NameTokens.input)
    @TabInfo(container = ApplicationPresenter.class, label = "Input",
        priority = 1)
    public interface MyProxy extends TabContentProxyPlace<InputTabPresenter> {
    }

    @Inject
    public InputTabPresenter(final EventBus eventBus, final MyView view,
        final MyProxy proxy, IGwtNumberFormatSux format
    ) {
        super(eventBus, view, proxy, ApplicationPresenter.TYPE_SetTabContent);
        this.eventBus = eventBus;
        this.view = view;
        this.format = format;
        format.setPattern("0.#");
        view.setUiHandlers(this);

    }

    @Override
    protected void onBind() {
        super.onBind();

        updateViewFromModel();
    }

    public void updateViewFromModel() {
        view.setValue(format.format(123.456));
    }

    @Override
    public void onValueChange(String value) {
    }

}
