package com.example.gwtpwj.client.app.input;

import java.util.logging.Logger;

import com.github.gwtbootstrap.client.ui.TextBox;
import com.google.gwt.event.dom.client.ChangeEvent;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiHandler;
import com.google.gwt.user.client.ui.Widget;
import com.google.inject.Inject;
import com.gwtplatform.mvp.client.ViewWithUiHandlers;

public class InputTabView
     extends ViewWithUiHandlers<InputTabUiHandlers>
    implements InputTabPresenter.MyView {

    private static Logger log = Logger.getLogger(
        InputTabView.class.getName());

    public interface Binder extends UiBinder<Widget, InputTabView> {
    }

    @UiField
    TextBox valueField;

    private Widget widget;

    @Inject
    public InputTabView(final Binder uiBinder) {
        widget = uiBinder.createAndBindUi(this);
        initWidget(widget);
    }

    @UiHandler("valueField")
    void onIncomeChange(ChangeEvent event) {
        if (getUiHandlers() != null) {
            try {
                getUiHandlers().onValueChange(
                    valueField.getText());
            } catch (Exception e) {
                log.warning("Could not set value. " + e.getMessage());
            }
        }
    }

    @Override
    public Widget asWidget() {
        return widget;
    }

    @Override
    public void setValue(String value) {
        valueField.setValue(value);
    }

}
