package com.example.gwtpwj.client;

import org.gwt.advanced.client.ui.widget.ComboBox;
import org.jukito.JukitoModule;


import com.example.gwtpwj.client.app.input.InputTabView;
import com.example.gwtpwj.client.app.input.InputTabView.Binder;
import com.example.gwtpwj.client.model.IGwtNumberFormatSux;
import com.example.gwtpwj.server.JavaNumberFormat;
import com.google.gwt.junit.GWTMockUtilities;
import com.google.gwt.user.client.ui.CheckBox;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Widget;
import com.google.inject.Inject;
import com.gwtplatform.tester.MockingBinder;

/**
 * This is the Guice test module. Jukito runs the configureTest() method
 * to setup all the bindings used in the following unit tests.
 */
public abstract class AJukitoModule extends JukitoModule {
    /**
     * This is the test binder extending `MockingBinder` and
     * implementing the view's `Binder`.
     */
    static class MyTestBinder extends MockingBinder<Widget, InputTabView>
        implements Binder
    {
        @Inject
        public MyTestBinder(final MockitoMockFactory mockFactory) {
            super(Widget.class, mockFactory);
        }

    }

    @Override
    protected void configureTest() {
        GWTMockUtilities.disarm();
        bind(Binder.class).to(AJukitoModule.MyTestBinder.class);
        bind(IGwtNumberFormatSux.class).to(JavaNumberFormat.class);
        forceMock(Label.class);
        forceMock(ComboBox.class);
        forceMock(CheckBox.class);
        // forceMock(IGwtNumberFormatSux.class);
        // bindSpy(JavaNumberFormat.class);
    }
}
